std::is_null_pointer(3)

NAME
std::is_null_pointer - std::is_null_pointer

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++14)
   struct is_null_pointer;
   std::is_null_pointer is a UnaryTypeTrait.
   Checks whether T is the type std::nullptr_t.
   Provides the member constant value that is equal to true, if T is the type
   std::nullptr_t, const std::nullptr_t, volatile std::nullptr_t, or const volatile
   std::nullptr_t.
   Otherwise, value is equal to false.
   If the program adds specializations for std::is_null_pointer
   or std::is_null_pointer_v
   (since C++17), the behavior is undefined.

Template parameters
   T - a type to check
   Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_null_pointer_v = is_null_pointer<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is the type std::nullptr_t (possibly cv-qualified), false
   [static] otherwise
            (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Possible implementation
   template<class T>
   struct is_null_pointer : std::is_same<std::nullptr_t, std::remove_cv_t<T>> {};

Notes
   std::is_pointer is false for std::nullptr_t because it is not a built-in pointer
   type.
      Feature-test macro Value Std Feature
   __cpp_lib_is_null_pointer 201309L (C++14) std::is_null_pointer

Example
// Run this code
 #include <type_traits>
 static_assert(std::is_null_pointer_v<decltype(nullptr)>);
 static_assert(!std::is_null_pointer_v<int*>);
 static_assert(!std::is_pointer_v<decltype(nullptr)>);
 static_assert(std::is_pointer_v<int*>);
 int main()
 {
 }

See also
   is_void checks if a type is void
   (C++11) (class template)
   is_array checks if a type is an array type
   (C++11) (class template)
   is_pointer checks if a type is a pointer type
   (C++11) (class template)
   is_enum checks if a type is an enumeration type
   (C++11) (class template)
   is_union checks if a type is a union type
   (C++11) (class template)
   is_class checks if a type is a non-union class type
   (C++11) (class template)
   is_function checks if a type is a function type
   (C++11) (class template)
   is_object checks if a type is an object type
   (C++11) (class template)